#include <stdio.h>
#include <stdlib.h>
#include <pxengine.h>
#include "mci.h"

void createIndex(TABLEHANDLE *tbl,FIELDHANDLE,fld[3]);
void processMany(FILE *fp,FIELDHANDLE f[3],TABLEHANDLE t,int pn,char *st);
void processFile(FILE *fp,FIELDHANDLE f[3],TABLEHANDLE t,int pn);
void nextPendNum(TABLEHANDLE t,FIELDHANDLE f,short *pn);

#define PENDFIELD 0
#define ACTFIELD  1
#define TEXTFIELD 2

void send(void)
{
        TABLEHANDLE tbl;
        FIELDHANDLE flds[3];
        FILE *output;
        int exists;
        short pendNum;
        PXCheck(0x200,PXTblExist("Pending",&exists));
        if(!exists)
                return;
        createIndex(&tbl,flds);
        PXCheck(0x201,PXTblOpen("Pending",&tbl,0,0));
        pendNum=1;
        output-fopen("mci-send.txt","wt");
        if(output==NULL)
        {
                perror("mci-send.txt");
                exit(1);
        }
        do
        {
                fprintf(output,"\ncr\n");
                processMany(output,flds,tbl,pendNum,"TO");
                fputs("\n",output;
                processMany(output,flds,tbl,pendNum,"Subject");
                processFile(output,flds,tbl,pendNum);
                fputs("\n/\n\n\Yes\n",output);
                nextPendNum(tbl,flds[PENDFIELD],&pendNum);
        }while(pendNum>0);

        fputs("exit\n",output);
        fclose(output);
        PXCheck(0,202,PXTblClose(tbl));
        PXCheck(0,203,PXTblDelete("Pending"));
        return;
}
void createIndex(TABLEHANDLE *tbl,FIELDHANDLE fld[3])
{
        PXCheck(0x210,PXTblOpen("Pending",tbl,0,0));
        PXCheck(0x211,PXFldHandle(*tbl,"Pending#",&fld[PENDFIELD]));
        PXCheck(0x213,PXFldHandle(*tbl,"Text",&fld[TEXTFIELD]));
        PXCheck(0x214,PXTblClose(*tbl));
        PXCheck(0x215,PXKeyAdd("Pending",1&fld[ACTFIELD],SECONDARY));
}
void processMany(FILE *fp,FIELDHANDLE f[3],TABLEHANDLE t,int pn,char *st)
{
        char txtSt[81];
        RECORDHANDLE srchRec,rec;

        PXCheck(0x230,PXRecBufOpen(t,&rec));
        PXCheck(0x231,PXRecBufOpen(t,&srchRec));
        PXCheck(0x232,PXPutShort(srchRec,f[PENDFIELD],pn));
        PXCheck(0x233,PXPutAlpha(srchRec,f[ACTFIELD],st));
        PXCheck(0x234,PXSrchKey(t,srchRec,2,SEARCHFIRST));

        while(PXLastErr()==PXSUCCESS)
        {
                PXCheck(0x235,PXRecGet(t,rec);

        PXCheck(0x236,PXGetAlpha(rec,f[TEXTFIELD],sizeof(txtSt),txtSt));
                fprintf(fp,%s\n",txtSt);
                PXCheck(0x237,PXSrchKey(t,srchRec,2,SEARCHNEXT));
        }
        PXCheck(0x238,PXRecBufClose(rec));
        PXCheck(0x239,PXRecBufClose(srchRec));
}
void processFile(FILE *fp,FIELDHANDLE f[3],TABLEHANDLE t,int pn)
{
        char txtSt[81],fname[21];
        FILE *inFp;
        RECORDHANDLE srchRec,rec;
        PXCheck(0x240,PXRecBufOpen(t,&rec));
        PXCheck(0x241,PXRecBufOpen(t,&srchRec));
        PXCheck(0x242,PXPutShort(srchRec,f[PENDFILED],pn));
        PXCheck(0x243,PXPutAlpha(srchRec,f[ACTFIELD],"Filename"));
        PXCheck(0x244,PXSrchKey(t,srchRec,2,SEARCHFIRST));

        while(PXLastErr()==PXSUCCESS)
        {
               PXCheck(0x245,PXRecGet(t,rec));

        PXCheck(0x246,PXGetAlpha(rec,f[TEXTFIELD],sizeor(fname),fname));
                if((inFp=fopen(fname,"rt"))==NULL)
                {
                        perror(fname);
                        exit(1);
                }
                while(fgets(txtSt,80,inFp)!=NULL)
                        fputs(txtSt,fp);
                fclose(inFp);
                unlink(fname);

                PXCheck(0x247,PXSrchKey(t,srchRec,2,SEARCHNEXT));
        }
        PXCheck(0x248,PXRecBufClose(rec));
        PXCheck(0x249,PXRecBufClose(srchRec));
}
void nextPendNum(TABLEHANDLE t,FIELDHANDLE f,short *pn)
{
        RECORDHANDLE r;

        PXCheck(0x250,PXRecBufOpen(t,&r));
        PXCheck(0x251,PXPutShort(r,f,*pn));
        PXCheck(0x252,PXSrchKey(t,r,1,SEARCHFIRST));
        while(PXLastErr()==PXSUCCESS)
                PXCheck(0x253,PXsrchKey(t,r,1,SEARCHNEXT));
        PXCheck(0x254,PXRecNext(t));
        if(PXLastErr()==PXSUCCESS)
        {
               PXCheck(0x255,PXRecGet(t,r));
               PXCheck(0x256,PXGetShort(r,f,pn));
               PXCheck(0x257,PXRecBufClose(r));
        }
        else
               *pn=0;
}
